// Basic.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Basic.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBasicApp

BEGIN_MESSAGE_MAP(CBasicApp, CWinApp)
	//{{AFX_MSG_MAP(CBasicApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBasicApp construction

CBasicApp::CBasicApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBasicApp object

CBasicApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBasicApp initialization

BOOL CBasicApp::InitInstance()
{
	// Create the main window
	C3dWnd* pWnd = new C3dWnd;
	pWnd->Create("3D Basics", 
                 WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				 50, 50,
                 400, 350);
	m_pMainWnd = pWnd;
	pWnd->UpdateWindow();

	// Create an initial scene we can add objects to
	static C3dScene scene;
	scene.Create();

	// Set ambient light level
    scene.SetAmbientLight(0.4, 0.4, 0.4);

	// Add directional light to create highlights
    static C3dDirLight dl;
    dl.Create(0.8, 0.8, 0.8);
    scene.AddChild(&dl);
    dl.SetPosition(-2, 2, -5);
    dl.SetDirection(1, -1, 1);

	// Create big white sphere
	static C3dShape sh1;
	sh1.CreateSphere(1);

	// Add big white sphere to scene
	scene.AddChild(&sh1);

	// Create small blue sphere
	static C3dShape sh2;
	sh2.CreateSphere(0.3);
	sh2.SetColor(0, 0, 1);

	// Attach blue sphere to white one
	sh1.AddChild(&sh2);

	// Set blue sphere's position relative
	// to white sphere
	sh2.SetPosition(0, 0, -2);

	// Create small red sphere
	static C3dShape sh3;
	sh3.CreateSphere(0.15);
	sh3.SetColor(1, 0, 0);

	// Attach red sphere to white one
	sh1.AddChild(&sh3);

	// Set red sphere's position relative
	// to white sphere
	sh3.SetPosition(0, 0, 5);

	// Start rotating big sphere slowly around 
	// the 1, 1, 0 axis
	sh1.SetRotation(1, 1, 0, 0.015);

	// Attach entire scene to the stage
	pWnd->SetScene(&scene);

	return TRUE;
}

BOOL CBasicApp::OnIdle(LONG lCount) 
{
	BOOL bMore = CWinApp::OnIdle(lCount);
	
	if (m_pMainWnd) {
		C3dWnd* pWnd = (C3dWnd*) m_pMainWnd;

		// Tell 3D window to move scene one unit,
		// and redraw window
		if (pWnd->Update(1)) {
			bMore = TRUE;
		} 
	}
	return bMore;
}

